import { DynamicModule, Provider } from '@nestjs/common';
import { ObjectionModuleAsyncOptions, ObjectionModuleOptions } from './objection.interfaces';
export declare class ObjectionCoreModule {
    static forRoot(options: ObjectionModuleOptions, connection?: string): DynamicModule;
    static forRootAsync(options: ObjectionModuleAsyncOptions, connection: string): DynamicModule;
    static createAsyncProviders(options: ObjectionModuleAsyncOptions, connection?: string): Provider[];
    static createAsyncOptionsProvider(options: ObjectionModuleAsyncOptions, connection?: string): Provider;
}
