"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var ObjectionModule_1;
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("@nestjs/common");
const objection_core_module_1 = require("./objection.core-module");
const objection_utils_1 = require("./objection.utils");
let ObjectionModule = ObjectionModule_1 = class ObjectionModule {
    static forRoot(options, connection) {
        return {
            module: ObjectionModule_1,
            imports: [objection_core_module_1.ObjectionCoreModule.forRoot(options, connection)],
            exports: [objection_core_module_1.ObjectionCoreModule],
        };
    }
    static forRootAsync(options, connection) {
        return {
            module: ObjectionModule_1,
            imports: [objection_core_module_1.ObjectionCoreModule.forRootAsync(options, connection)],
            exports: [objection_core_module_1.ObjectionCoreModule],
        };
    }
    static forFeature(models, connection) {
        const providers = (models || []).map(model => ({
            provide: objection_utils_1.getObjectionModelToken(model, connection),
            useValue: model,
        }));
        return {
            module: ObjectionModule_1,
            providers: providers,
            exports: providers,
        };
    }
};
ObjectionModule = ObjectionModule_1 = __decorate([
    common_1.Module({})
], ObjectionModule);
exports.ObjectionModule = ObjectionModule;
